# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`r10k`](#r10k): This class configures r10k
* [`r10k::config`](#r10k--config): == Class: r10k::config  Set up the root r10k config file (/etc/r10k.yaml).  === Parameters  * [*cachedir*]   Path to a directory to be used b
* [`r10k::install`](#r10k--install): This class is used by the ruby or pe_ruby class
* [`r10k::install::bundle`](#r10k--install--bundle): This class installs the r10k bundle
* [`r10k::install::gem`](#r10k--install--gem): Install the r10k gem using system ruby
* [`r10k::install::puppet_gem`](#r10k--install--puppet_gem): This class links the r10k binary for Puppet FOSS 4.2 and up
* [`r10k::mcollective`](#r10k--mcollective): Install the r10k mcollective agent
* [`r10k::mcollective::application`](#r10k--mcollective--application): Install the r10k mcollective application to a client
* [`r10k::params`](#r10k--params): Reasonable defaults for all classes
* [`r10k::postrun_command`](#r10k--postrun_command): This class will configure r10k to run as part of the masters agent run
* [`r10k::prerun_command`](#r10k--prerun_command): This class will configure r10k to run as part of the masters agent run
* [`r10k::webhook`](#r10k--webhook): This class creates a github webhoook to allow curl style post-rec scripts
* [`r10k::webhook::config`](#r10k--webhook--config): == Class: r10k::webhook::config  Set up the root r10k config file (/etc/webhook.yaml).  === Authors  Zack Smith <zack@puppetlabs.com>
* [`r10k::webhook::package`](#r10k--webhook--package): Private class, do not include it directly. Installs the webhook packages

### Tasks

* [`deploy`](#deploy): Trigger an r10k deployment.

## Classes

### <a name="r10k"></a>`r10k`

This class configures r10k

#### Parameters

The following parameters are available in the `r10k` class:

* [`remote`](#-r10k--remote)
* [`sources`](#-r10k--sources)
* [`cachedir`](#-r10k--cachedir)
* [`configfile`](#-r10k--configfile)
* [`version`](#-r10k--version)
* [`puppet_master`](#-r10k--puppet_master)
* [`modulepath`](#-r10k--modulepath)
* [`manage_modulepath`](#-r10k--manage_modulepath)
* [`manage_ruby_dependency`](#-r10k--manage_ruby_dependency)
* [`r10k_basedir`](#-r10k--r10k_basedir)
* [`package_name`](#-r10k--package_name)
* [`provider`](#-r10k--provider)
* [`gentoo_keywords`](#-r10k--gentoo_keywords)
* [`install_options`](#-r10k--install_options)
* [`mcollective`](#-r10k--mcollective)
* [`manage_configfile_symlink`](#-r10k--manage_configfile_symlink)
* [`configfile_symlink`](#-r10k--configfile_symlink)
* [`git_settings`](#-r10k--git_settings)
* [`forge_settings`](#-r10k--forge_settings)
* [`deploy_settings`](#-r10k--deploy_settings)
* [`root_user`](#-r10k--root_user)
* [`proxy`](#-r10k--proxy)
* [`pool_size`](#-r10k--pool_size)
* [`gem_source`](#-r10k--gem_source)
* [`root_group`](#-r10k--root_group)
* [`postrun`](#-r10k--postrun)
* [`include_prerun_command`](#-r10k--include_prerun_command)
* [`include_postrun_command`](#-r10k--include_postrun_command)

##### <a name="-r10k--remote"></a>`remote`

Data type: `Any`



Default value: `$r10k::params::remote`

##### <a name="-r10k--sources"></a>`sources`

Data type: `Any`



Default value: `$r10k::params::sources`

##### <a name="-r10k--cachedir"></a>`cachedir`

Data type: `Any`



Default value: `$r10k::params::r10k_cache_dir`

##### <a name="-r10k--configfile"></a>`configfile`

Data type: `Any`



Default value: `$r10k::params::r10k_config_file`

##### <a name="-r10k--version"></a>`version`

Data type: `Any`



Default value: `$r10k::params::version`

##### <a name="-r10k--puppet_master"></a>`puppet_master`

Data type: `Any`



Default value: `$r10k::params::puppet_master`

##### <a name="-r10k--modulepath"></a>`modulepath`

Data type: `Any`



Default value: `$r10k::params::modulepath`

##### <a name="-r10k--manage_modulepath"></a>`manage_modulepath`

Data type: `Any`



Default value: `$r10k::params::manage_modulepath`

##### <a name="-r10k--manage_ruby_dependency"></a>`manage_ruby_dependency`

Data type: `Enum['include','declare','ignore']`



Default value: `$r10k::params::manage_ruby_dependency`

##### <a name="-r10k--r10k_basedir"></a>`r10k_basedir`

Data type: `Any`



Default value: `$r10k::params::r10k_basedir`

##### <a name="-r10k--package_name"></a>`package_name`

Data type: `Any`



Default value: `$r10k::params::package_name`

##### <a name="-r10k--provider"></a>`provider`

Data type: `Any`



Default value: `$r10k::params::provider`

##### <a name="-r10k--gentoo_keywords"></a>`gentoo_keywords`

Data type: `Any`



Default value: `$r10k::params::gentoo_keywords`

##### <a name="-r10k--install_options"></a>`install_options`

Data type: `Any`



Default value: `$r10k::params::install_options`

##### <a name="-r10k--mcollective"></a>`mcollective`

Data type: `Any`



Default value: `$r10k::params::mcollective`

##### <a name="-r10k--manage_configfile_symlink"></a>`manage_configfile_symlink`

Data type: `Any`



Default value: `$r10k::params::manage_configfile_symlink`

##### <a name="-r10k--configfile_symlink"></a>`configfile_symlink`

Data type: `Any`



Default value: `$r10k::params::configfile_symlink`

##### <a name="-r10k--git_settings"></a>`git_settings`

Data type: `Hash`



Default value: `$r10k::params::git_settings`

##### <a name="-r10k--forge_settings"></a>`forge_settings`

Data type: `Hash`



Default value: `$r10k::params::forge_settings`

##### <a name="-r10k--deploy_settings"></a>`deploy_settings`

Data type: `Hash`



Default value: `$r10k::params::deploy_settings`

##### <a name="-r10k--root_user"></a>`root_user`

Data type: `Any`



Default value: `$r10k::params::root_user`

##### <a name="-r10k--proxy"></a>`proxy`

Data type: `Optional[String[1]]`



Default value: `$r10k::params::proxy`

##### <a name="-r10k--pool_size"></a>`pool_size`

Data type: `Optional[Integer[1]]`



Default value: `$r10k::params::pool_size`

##### <a name="-r10k--gem_source"></a>`gem_source`

Data type: `Optional[String[1]]`



Default value: `$r10k::params::gem_source`

##### <a name="-r10k--root_group"></a>`root_group`

Data type: `Any`



Default value: `$r10k::params::root_group`

##### <a name="-r10k--postrun"></a>`postrun`

Data type: `Any`



Default value: `undef`

##### <a name="-r10k--include_prerun_command"></a>`include_prerun_command`

Data type: `Boolean`



Default value: `false`

##### <a name="-r10k--include_postrun_command"></a>`include_postrun_command`

Data type: `Boolean`



Default value: `false`

### <a name="r10k--config"></a>`r10k::config`

== Class: r10k::config

Set up the root r10k config file (/etc/r10k.yaml).

=== Parameters

* [*cachedir*]
  Path to a directory to be used by r10k for caching data.
  Default: /var/cache/r10k
* [*sources*]
  Hash containing data sources to be used by r10k to create dynamic Puppet
  environments. Default: {}
* [*postrun*]
  **Optional:** Array containing the parts of a system call.
  Example: ['/usr/bin/curl', '-F', 'deploy=done', 'http://my-app.site/endpoint']
  Default: undef
* [*manage_configfile_symlink*]
  Boolean to determine if a symlink to the r10k config file is to be managed.
  Default: false
* [*configfile_symlink*]
  Location of symlink that points to configfile. Default: /etc/r10k.yaml
* [*forge_settings*]
  Hash containing settings for downloading modules from the Puppet Forge.
* [*proxy*]
  String containing proxy setting for r10k.yaml.
  Default: undef
* [*pool_size*]
  Integer defining how many threads should be spawn while updating modules. Only available for r10k >= 3.3.0.
  Default: undef

=== Examples

 class { 'r10k::config':
   sources => {
     'somename' => {
       'remote'  => 'ssh://git@github.com/someuser/somerepo.git',
       'basedir' => "${::settings::confdir}/environments"
     },
     'someothername' => {
       'remote'  => 'ssh://git@github.com/someuser/someotherrepo.git',
       'basedir' => '/some/other/basedir'
     },
   },
 }

== Documentation

* https://github.com/adrienthebo/r10k#dynamic-environment-configuration

=== Authors

Charlie Sharpsteen <source@sharpsteen.net>
Zack Smith <zack@puppetlabs.com>

#### Parameters

The following parameters are available in the `r10k::config` class:

* [`configfile`](#-r10k--config--configfile)
* [`cachedir`](#-r10k--config--cachedir)
* [`sources`](#-r10k--config--sources)
* [`modulepath`](#-r10k--config--modulepath)
* [`remote`](#-r10k--config--remote)
* [`manage_modulepath`](#-r10k--config--manage_modulepath)
* [`r10k_basedir`](#-r10k--config--r10k_basedir)
* [`manage_configfile_symlink`](#-r10k--config--manage_configfile_symlink)
* [`configfile_symlink`](#-r10k--config--configfile_symlink)
* [`git_settings`](#-r10k--config--git_settings)
* [`forge_settings`](#-r10k--config--forge_settings)
* [`deploy_settings`](#-r10k--config--deploy_settings)
* [`postrun`](#-r10k--config--postrun)
* [`root_user`](#-r10k--config--root_user)
* [`root_group`](#-r10k--config--root_group)
* [`puppetconf_path`](#-r10k--config--puppetconf_path)
* [`proxy`](#-r10k--config--proxy)
* [`pool_size`](#-r10k--config--pool_size)
* [`r10k_yaml_template`](#-r10k--config--r10k_yaml_template)

##### <a name="-r10k--config--configfile"></a>`configfile`

Data type: `Any`



Default value: `$r10k::params::r10k_config_file`

##### <a name="-r10k--config--cachedir"></a>`cachedir`

Data type: `Any`



Default value: `$r10k::params::r10k_cache_dir`

##### <a name="-r10k--config--sources"></a>`sources`

Data type: `Optional[Hash]`



Default value: `$r10k::params::sources`

##### <a name="-r10k--config--modulepath"></a>`modulepath`

Data type: `Any`



Default value: `$r10k::params::modulepath`

##### <a name="-r10k--config--remote"></a>`remote`

Data type: `Any`



Default value: `$r10k::params::remote`

##### <a name="-r10k--config--manage_modulepath"></a>`manage_modulepath`

Data type: `Boolean`



Default value: `$r10k::params::manage_modulepath`

##### <a name="-r10k--config--r10k_basedir"></a>`r10k_basedir`

Data type: `Stdlib::Absolutepath`



Default value: `$r10k::params::r10k_basedir`

##### <a name="-r10k--config--manage_configfile_symlink"></a>`manage_configfile_symlink`

Data type: `Boolean`



Default value: `$r10k::params::manage_configfile_symlink`

##### <a name="-r10k--config--configfile_symlink"></a>`configfile_symlink`

Data type: `Stdlib::Absolutepath`



Default value: `$r10k::params::configfile_symlink`

##### <a name="-r10k--config--git_settings"></a>`git_settings`

Data type: `Hash`



Default value: `$r10k::params::git_settings`

##### <a name="-r10k--config--forge_settings"></a>`forge_settings`

Data type: `Hash`



Default value: `$r10k::params::forge_settings`

##### <a name="-r10k--config--deploy_settings"></a>`deploy_settings`

Data type: `Hash`



Default value: `$r10k::params::deploy_settings`

##### <a name="-r10k--config--postrun"></a>`postrun`

Data type: `Optional[Array]`



Default value: `undef`

##### <a name="-r10k--config--root_user"></a>`root_user`

Data type: `Any`



Default value: `$r10k::params::root_user`

##### <a name="-r10k--config--root_group"></a>`root_group`

Data type: `Any`



Default value: `$r10k::params::root_group`

##### <a name="-r10k--config--puppetconf_path"></a>`puppetconf_path`

Data type: `Stdlib::Absolutepath`



Default value: `$r10k::params::puppetconf_path`

##### <a name="-r10k--config--proxy"></a>`proxy`

Data type: `Optional[String[1]]`



Default value: `$r10k::params::proxy`

##### <a name="-r10k--config--pool_size"></a>`pool_size`

Data type: `Optional[Integer[1]]`



Default value: `$r10k::params::pool_size`

##### <a name="-r10k--config--r10k_yaml_template"></a>`r10k_yaml_template`

Data type: `String`



Default value: `'r10k/r10k.yaml.erb'`

### <a name="r10k--install"></a>`r10k::install`

This class is used by the ruby or pe_ruby class

#### Parameters

The following parameters are available in the `r10k::install` class:

* [`package_name`](#-r10k--install--package_name)
* [`version`](#-r10k--install--version)
* [`provider`](#-r10k--install--provider)
* [`keywords`](#-r10k--install--keywords)
* [`install_options`](#-r10k--install--install_options)
* [`manage_ruby_dependency`](#-r10k--install--manage_ruby_dependency)
* [`puppet_master`](#-r10k--install--puppet_master)
* [`is_pe_server`](#-r10k--install--is_pe_server)
* [`gem_source`](#-r10k--install--gem_source)

##### <a name="-r10k--install--package_name"></a>`package_name`

Data type: `Any`



##### <a name="-r10k--install--version"></a>`version`

Data type: `Any`



##### <a name="-r10k--install--provider"></a>`provider`

Data type: `Any`



##### <a name="-r10k--install--keywords"></a>`keywords`

Data type: `Any`



##### <a name="-r10k--install--install_options"></a>`install_options`

Data type: `Any`



##### <a name="-r10k--install--manage_ruby_dependency"></a>`manage_ruby_dependency`

Data type: `Any`



##### <a name="-r10k--install--puppet_master"></a>`puppet_master`

Data type: `Any`



Default value: `true`

##### <a name="-r10k--install--is_pe_server"></a>`is_pe_server`

Data type: `Any`



Default value: `$r10k::params::is_pe_server`

##### <a name="-r10k--install--gem_source"></a>`gem_source`

Data type: `Optional[String[1]]`



Default value: `undef`

### <a name="r10k--install--bundle"></a>`r10k::install::bundle`

This class installs the r10k bundle

#### Parameters

The following parameters are available in the `r10k::install::bundle` class:

* [`revision`](#-r10k--install--bundle--revision)
* [`source`](#-r10k--install--bundle--source)

##### <a name="-r10k--install--bundle--revision"></a>`revision`

Data type: `Any`



Default value: `'master'`

##### <a name="-r10k--install--bundle--source"></a>`source`

Data type: `Any`



Default value: `'https://github.com/adrienthebo/r10k.git'`

### <a name="r10k--install--gem"></a>`r10k::install::gem`

Install the r10k gem using system ruby

#### Parameters

The following parameters are available in the `r10k::install::gem` class:

* [`manage_ruby_dependency`](#-r10k--install--gem--manage_ruby_dependency)
* [`version`](#-r10k--install--gem--version)

##### <a name="-r10k--install--gem--manage_ruby_dependency"></a>`manage_ruby_dependency`

Data type: `Any`



##### <a name="-r10k--install--gem--version"></a>`version`

Data type: `Any`



### <a name="r10k--install--puppet_gem"></a>`r10k::install::puppet_gem`

This class links the r10k binary for Puppet FOSS 4.2 and up

### <a name="r10k--mcollective"></a>`r10k::mcollective`

Install the r10k mcollective agent

#### Parameters

The following parameters are available in the `r10k::mcollective` class:

* [`ensure`](#-r10k--mcollective--ensure)
* [`server`](#-r10k--mcollective--server)
* [`client`](#-r10k--mcollective--client)
* [`http_proxy`](#-r10k--mcollective--http_proxy)
* [`policies`](#-r10k--mcollective--policies)

##### <a name="-r10k--mcollective--ensure"></a>`ensure`

Data type: `Any`



Default value: `'present'`

##### <a name="-r10k--mcollective--server"></a>`server`

Data type: `Any`



Default value: `true`

##### <a name="-r10k--mcollective--client"></a>`client`

Data type: `Any`



Default value: `true`

##### <a name="-r10k--mcollective--http_proxy"></a>`http_proxy`

Data type: `Any`



Default value: `''`

##### <a name="-r10k--mcollective--policies"></a>`policies`

Data type: `Any`



Default value: `[]`

### <a name="r10k--mcollective--application"></a>`r10k::mcollective::application`

Install the r10k mcollective application to a client

#### Parameters

The following parameters are available in the `r10k::mcollective::application` class:

* [`agent_name`](#-r10k--mcollective--application--agent_name)
* [`app_name`](#-r10k--mcollective--application--app_name)
* [`agent_ddl`](#-r10k--mcollective--application--agent_ddl)
* [`agent_path`](#-r10k--mcollective--application--agent_path)
* [`app_path`](#-r10k--mcollective--application--app_path)
* [`mc_service`](#-r10k--mcollective--application--mc_service)

##### <a name="-r10k--mcollective--application--agent_name"></a>`agent_name`

Data type: `Any`



Default value: `$r10k::params::mc_agent_name`

##### <a name="-r10k--mcollective--application--app_name"></a>`app_name`

Data type: `Any`



Default value: `$r10k::params::mc_app_name`

##### <a name="-r10k--mcollective--application--agent_ddl"></a>`agent_ddl`

Data type: `Any`



Default value: `$r10k::params::mc_agent_ddl_name`

##### <a name="-r10k--mcollective--application--agent_path"></a>`agent_path`

Data type: `Any`



Default value: `$r10k::params::mc_agent_path`

##### <a name="-r10k--mcollective--application--app_path"></a>`app_path`

Data type: `Any`



Default value: `$r10k::params::mc_application_path`

##### <a name="-r10k--mcollective--application--mc_service"></a>`mc_service`

Data type: `Any`



Default value: `$r10k::params::mc_service_name`

### <a name="r10k--params"></a>`r10k::params`

Reasonable defaults for all classes

### <a name="r10k--postrun_command"></a>`r10k::postrun_command`

This class will configure r10k to run as part of the masters agent run

#### Parameters

The following parameters are available in the `r10k::postrun_command` class:

* [`command`](#-r10k--postrun_command--command)
* [`ensure`](#-r10k--postrun_command--ensure)

##### <a name="-r10k--postrun_command--command"></a>`command`

Data type: `Any`



Default value: `$r10k::params::pre_postrun_command`

##### <a name="-r10k--postrun_command--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`



Default value: `'present'`

### <a name="r10k--prerun_command"></a>`r10k::prerun_command`

This class will configure r10k to run as part of the masters agent run

#### Parameters

The following parameters are available in the `r10k::prerun_command` class:

* [`command`](#-r10k--prerun_command--command)
* [`ensure`](#-r10k--prerun_command--ensure)

##### <a name="-r10k--prerun_command--command"></a>`command`

Data type: `Any`



Default value: `$r10k::params::pre_postrun_command`

##### <a name="-r10k--prerun_command--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`



Default value: `'present'`

### <a name="r10k--webhook"></a>`r10k::webhook`

This class creates a github webhoook to allow curl style post-rec scripts

#### Parameters

The following parameters are available in the `r10k::webhook` class:

* [`ensure`](#-r10k--webhook--ensure)
* [`user`](#-r10k--webhook--user)
* [`group`](#-r10k--webhook--group)
* [`background`](#-r10k--webhook--background)
* [`bin_template`](#-r10k--webhook--bin_template)
* [`service_template`](#-r10k--webhook--service_template)
* [`service_file`](#-r10k--webhook--service_file)
* [`service_file_mode`](#-r10k--webhook--service_file_mode)
* [`use_mcollective`](#-r10k--webhook--use_mcollective)
* [`is_pe_server`](#-r10k--webhook--is_pe_server)
* [`root_user`](#-r10k--webhook--root_user)
* [`root_group`](#-r10k--webhook--root_group)
* [`manage_packages`](#-r10k--webhook--manage_packages)
* [`ruby_bin`](#-r10k--webhook--ruby_bin)

##### <a name="-r10k--webhook--ensure"></a>`ensure`

Data type: `Any`



Default value: `true`

##### <a name="-r10k--webhook--user"></a>`user`

Data type: `Any`



Default value: `$r10k::params::webhook_user`

##### <a name="-r10k--webhook--group"></a>`group`

Data type: `Any`



Default value: `$r10k::params::webhook_group`

##### <a name="-r10k--webhook--background"></a>`background`

Data type: `Any`



Default value: `$r10k::params::webhook_background`

##### <a name="-r10k--webhook--bin_template"></a>`bin_template`

Data type: `Any`



Default value: `$r10k::params::webhook_bin_template`

##### <a name="-r10k--webhook--service_template"></a>`service_template`

Data type: `Any`



Default value: `'webhook.service.epp'`

##### <a name="-r10k--webhook--service_file"></a>`service_file`

Data type: `Any`



Default value: `$r10k::params::webhook_service_file`

##### <a name="-r10k--webhook--service_file_mode"></a>`service_file_mode`

Data type: `Any`



Default value: `$r10k::params::webhook_service_file_mode`

##### <a name="-r10k--webhook--use_mcollective"></a>`use_mcollective`

Data type: `Any`



Default value: `$r10k::params::webhook_use_mcollective`

##### <a name="-r10k--webhook--is_pe_server"></a>`is_pe_server`

Data type: `Any`



Default value: `$r10k::params::is_pe_server`

##### <a name="-r10k--webhook--root_user"></a>`root_user`

Data type: `Any`



Default value: `$r10k::params::root_user`

##### <a name="-r10k--webhook--root_group"></a>`root_group`

Data type: `Any`



Default value: `$r10k::params::root_group`

##### <a name="-r10k--webhook--manage_packages"></a>`manage_packages`

Data type: `Any`



Default value: `true`

##### <a name="-r10k--webhook--ruby_bin"></a>`ruby_bin`

Data type: `Any`



Default value: `undef`

### <a name="r10k--webhook--config"></a>`r10k::webhook::config`

== Class: r10k::webhook::config

Set up the root r10k config file (/etc/webhook.yaml).

=== Authors

Zack Smith <zack@puppetlabs.com>

#### Parameters

The following parameters are available in the `r10k::webhook::config` class:

* [`ensure`](#-r10k--webhook--config--ensure)
* [`hash`](#-r10k--webhook--config--hash)
* [`certname`](#-r10k--webhook--config--certname)
* [`certpath`](#-r10k--webhook--config--certpath)
* [`user`](#-r10k--webhook--config--user)
* [`pass`](#-r10k--webhook--config--pass)
* [`bind_address`](#-r10k--webhook--config--bind_address)
* [`port`](#-r10k--webhook--config--port)
* [`access_logfile`](#-r10k--webhook--config--access_logfile)
* [`client_cfg`](#-r10k--webhook--config--client_cfg)
* [`default_branch`](#-r10k--webhook--config--default_branch)
* [`use_mco_ruby`](#-r10k--webhook--config--use_mco_ruby)
* [`protected`](#-r10k--webhook--config--protected)
* [`github_secret`](#-r10k--webhook--config--github_secret)
* [`gitlab_token`](#-r10k--webhook--config--gitlab_token)
* [`bitbucket_secret`](#-r10k--webhook--config--bitbucket_secret)
* [`discovery_timeout`](#-r10k--webhook--config--discovery_timeout)
* [`client_timeout`](#-r10k--webhook--config--client_timeout)
* [`prefix`](#-r10k--webhook--config--prefix)
* [`prefix_command`](#-r10k--webhook--config--prefix_command)
* [`server_software`](#-r10k--webhook--config--server_software)
* [`enable_ssl`](#-r10k--webhook--config--enable_ssl)
* [`use_mcollective`](#-r10k--webhook--config--use_mcollective)
* [`r10k_deploy_arguments`](#-r10k--webhook--config--r10k_deploy_arguments)
* [`public_key_path`](#-r10k--webhook--config--public_key_path)
* [`private_key_path`](#-r10k--webhook--config--private_key_path)
* [`yaml_template`](#-r10k--webhook--config--yaml_template)
* [`command_prefix`](#-r10k--webhook--config--command_prefix)
* [`repository_events`](#-r10k--webhook--config--repository_events)
* [`allow_uppercase`](#-r10k--webhook--config--allow_uppercase)
* [`slack_webhook`](#-r10k--webhook--config--slack_webhook)
* [`slack_channel`](#-r10k--webhook--config--slack_channel)
* [`slack_username`](#-r10k--webhook--config--slack_username)
* [`slack_proxy_url`](#-r10k--webhook--config--slack_proxy_url)
* [`slack_icon`](#-r10k--webhook--config--slack_icon)
* [`rocketchat_webhook`](#-r10k--webhook--config--rocketchat_webhook)
* [`rocketchat_channel`](#-r10k--webhook--config--rocketchat_channel)
* [`rocketchat_username`](#-r10k--webhook--config--rocketchat_username)
* [`configfile_owner`](#-r10k--webhook--config--configfile_owner)
* [`configfile_group`](#-r10k--webhook--config--configfile_group)
* [`configfile_mode`](#-r10k--webhook--config--configfile_mode)
* [`configfile`](#-r10k--webhook--config--configfile)
* [`manage_symlink`](#-r10k--webhook--config--manage_symlink)
* [`configfile_symlink`](#-r10k--webhook--config--configfile_symlink)
* [`enable_mutex_lock`](#-r10k--webhook--config--enable_mutex_lock)
* [`ignore_environments`](#-r10k--webhook--config--ignore_environments)
* [`mco_arguments`](#-r10k--webhook--config--mco_arguments)
* [`generate_types`](#-r10k--webhook--config--generate_types)

##### <a name="-r10k--webhook--config--ensure"></a>`ensure`

Data type: `Any`



Default value: `true`

##### <a name="-r10k--webhook--config--hash"></a>`hash`

Data type: `Variant[String, Hash]`



Default value: `'UNSET'`

##### <a name="-r10k--webhook--config--certname"></a>`certname`

Data type: `Any`



Default value: `$r10k::params::webhook_certname`

##### <a name="-r10k--webhook--config--certpath"></a>`certpath`

Data type: `Any`



Default value: `$r10k::params::webhook_certpath`

##### <a name="-r10k--webhook--config--user"></a>`user`

Data type: `Any`



Default value: `$r10k::params::webhook_user`

##### <a name="-r10k--webhook--config--pass"></a>`pass`

Data type: `Any`



Default value: `$r10k::params::webhook_pass`

##### <a name="-r10k--webhook--config--bind_address"></a>`bind_address`

Data type: `Any`



Default value: `$r10k::params::webhook_bind_address`

##### <a name="-r10k--webhook--config--port"></a>`port`

Data type: `Any`



Default value: `$r10k::params::webhook_port`

##### <a name="-r10k--webhook--config--access_logfile"></a>`access_logfile`

Data type: `Variant[Stdlib::Absolutepath, Enum['stderr']]`



Default value: `'/var/log/webhook/access.log'`

##### <a name="-r10k--webhook--config--client_cfg"></a>`client_cfg`

Data type: `Any`



Default value: `$r10k::params::webhook_client_cfg`

##### <a name="-r10k--webhook--config--default_branch"></a>`default_branch`

Data type: `Any`



Default value: `$r10k::params::webhook_default_branch`

##### <a name="-r10k--webhook--config--use_mco_ruby"></a>`use_mco_ruby`

Data type: `Any`



Default value: `$r10k::params::webhook_use_mco_ruby`

##### <a name="-r10k--webhook--config--protected"></a>`protected`

Data type: `Any`



Default value: `$r10k::params::webhook_protected`

##### <a name="-r10k--webhook--config--github_secret"></a>`github_secret`

Data type: `Any`



Default value: `$r10k::params::webhook_github_secret`

##### <a name="-r10k--webhook--config--gitlab_token"></a>`gitlab_token`

Data type: `Any`



Default value: `$r10k::params::webhook_gitlab_token`

##### <a name="-r10k--webhook--config--bitbucket_secret"></a>`bitbucket_secret`

Data type: `Optional[String[1]]`



Default value: `$r10k::params::webhook_bitbucket_secret`

##### <a name="-r10k--webhook--config--discovery_timeout"></a>`discovery_timeout`

Data type: `Any`



Default value: `$r10k::params::webhook_discovery_timeout`

##### <a name="-r10k--webhook--config--client_timeout"></a>`client_timeout`

Data type: `Any`



Default value: `$r10k::params::webhook_client_timeout`

##### <a name="-r10k--webhook--config--prefix"></a>`prefix`

Data type: `Any`



Default value: `$r10k::params::webhook_prefix`

##### <a name="-r10k--webhook--config--prefix_command"></a>`prefix_command`

Data type: `Any`



Default value: `$r10k::params::webhook_prefix_command`

##### <a name="-r10k--webhook--config--server_software"></a>`server_software`

Data type: `Any`



Default value: `$r10k::params::webhook_server_software`

##### <a name="-r10k--webhook--config--enable_ssl"></a>`enable_ssl`

Data type: `Any`



Default value: `$r10k::params::webhook_enable_ssl`

##### <a name="-r10k--webhook--config--use_mcollective"></a>`use_mcollective`

Data type: `Any`



Default value: `$r10k::params::webhook_use_mcollective`

##### <a name="-r10k--webhook--config--r10k_deploy_arguments"></a>`r10k_deploy_arguments`

Data type: `Any`



Default value: `$r10k::params::webhook_r10k_deploy_arguments`

##### <a name="-r10k--webhook--config--public_key_path"></a>`public_key_path`

Data type: `Any`



Default value: `$r10k::params::webhook_public_key_path`

##### <a name="-r10k--webhook--config--private_key_path"></a>`private_key_path`

Data type: `Any`



Default value: `$r10k::params::webhook_private_key_path`

##### <a name="-r10k--webhook--config--yaml_template"></a>`yaml_template`

Data type: `Any`



Default value: `$r10k::params::webhook_yaml_template`

##### <a name="-r10k--webhook--config--command_prefix"></a>`command_prefix`

Data type: `Any`



Default value: `$r10k::params::webhook_r10k_command_prefix`

##### <a name="-r10k--webhook--config--repository_events"></a>`repository_events`

Data type: `Any`



Default value: `$r10k::params::webhook_repository_events`

##### <a name="-r10k--webhook--config--allow_uppercase"></a>`allow_uppercase`

Data type: `Any`



Default value: `$r10k::params::webhook_allow_uppercase`

##### <a name="-r10k--webhook--config--slack_webhook"></a>`slack_webhook`

Data type: `Any`



Default value: `$r10k::params::webhook_slack_webhook`

##### <a name="-r10k--webhook--config--slack_channel"></a>`slack_channel`

Data type: `Any`



Default value: `$r10k::params::webhook_slack_channel`

##### <a name="-r10k--webhook--config--slack_username"></a>`slack_username`

Data type: `Any`



Default value: `$r10k::params::webhook_slack_username`

##### <a name="-r10k--webhook--config--slack_proxy_url"></a>`slack_proxy_url`

Data type: `Any`



Default value: `$r10k::params::webhook_slack_proxy_url`

##### <a name="-r10k--webhook--config--slack_icon"></a>`slack_icon`

Data type: `Any`



Default value: `$r10k::params::webhook_slack_icon`

##### <a name="-r10k--webhook--config--rocketchat_webhook"></a>`rocketchat_webhook`

Data type: `Any`



Default value: `$r10k::params::webhook_rocketchat_webhook`

##### <a name="-r10k--webhook--config--rocketchat_channel"></a>`rocketchat_channel`

Data type: `Any`



Default value: `$r10k::params::webhook_rocketchat_channel`

##### <a name="-r10k--webhook--config--rocketchat_username"></a>`rocketchat_username`

Data type: `Any`



Default value: `$r10k::params::webhook_rocketchat_username`

##### <a name="-r10k--webhook--config--configfile_owner"></a>`configfile_owner`

Data type: `Any`



Default value: `$r10k::params::webhook_configfile_owner`

##### <a name="-r10k--webhook--config--configfile_group"></a>`configfile_group`

Data type: `Any`



Default value: `$r10k::params::webhook_configfile_group`

##### <a name="-r10k--webhook--config--configfile_mode"></a>`configfile_mode`

Data type: `Any`



Default value: `$r10k::params::webhook_configfile_mode`

##### <a name="-r10k--webhook--config--configfile"></a>`configfile`

Data type: `Any`



Default value: `'/etc/webhook.yaml'`

##### <a name="-r10k--webhook--config--manage_symlink"></a>`manage_symlink`

Data type: `Any`



Default value: `false`

##### <a name="-r10k--webhook--config--configfile_symlink"></a>`configfile_symlink`

Data type: `Any`



Default value: `'/etc/webhook.yaml'`

##### <a name="-r10k--webhook--config--enable_mutex_lock"></a>`enable_mutex_lock`

Data type: `Any`



Default value: `$r10k::params::webhook_enable_mutex_lock`

##### <a name="-r10k--webhook--config--ignore_environments"></a>`ignore_environments`

Data type: `Array`



Default value: `$r10k::params::webhook_ignore_environments`

##### <a name="-r10k--webhook--config--mco_arguments"></a>`mco_arguments`

Data type: `Optional[String]`



Default value: `$r10k::params::webhook_mco_arguments`

##### <a name="-r10k--webhook--config--generate_types"></a>`generate_types`

Data type: `Boolean`



Default value: `$r10k::params::webhook_generate_types`

### <a name="r10k--webhook--package"></a>`r10k::webhook::package`

Private class, do not include it directly.
Installs the webhook packages

#### Parameters

The following parameters are available in the `r10k::webhook::package` class:

* [`is_pe_server`](#-r10k--webhook--package--is_pe_server)
* [`provider`](#-r10k--webhook--package--provider)
* [`sinatra_version`](#-r10k--webhook--package--sinatra_version)
* [`webrick_version`](#-r10k--webhook--package--webrick_version)

##### <a name="-r10k--webhook--package--is_pe_server"></a>`is_pe_server`

Data type: `Any`



Default value: `$r10k::params::is_pe_server`

##### <a name="-r10k--webhook--package--provider"></a>`provider`

Data type: `Any`



Default value: `$r10k::params::provider`

##### <a name="-r10k--webhook--package--sinatra_version"></a>`sinatra_version`

Data type: `Any`



Default value: `$r10k::params::webhook_sinatra_version`

##### <a name="-r10k--webhook--package--webrick_version"></a>`webrick_version`

Data type: `Any`



Default value: `$r10k::params::webhook_webrick_version`

## Tasks

### <a name="deploy"></a>`deploy`

Trigger an r10k deployment.

**Supports noop?** false

#### Parameters

##### `environment`

Data type: `Optional[Pattern[/\A[a-zA-Z0-9_]+\Z/]]`

The environment to deploy.

##### `environments`

Data type: `Optional[Pattern[/\A[a-zA-Z0-9_,]+\Z/]]`

A comma separated list of environments to deploy. Takes precedence over `environment`.

##### `module`

Data type: `Optional[Pattern[/\A[a-z0-9_]+\Z/]]`

A module to deploy across all environments.

##### `modules`

Data type: `Optional[Pattern[/\A[a-z0-9_,]+\Z/]]`

A comma separated list of modules to deploy. Takes precedence over `module`.

